﻿Imports System.IO
Imports System.Runtime.InteropServices
Imports System.Security.Principal

Public Class RepairMainForm

    Const contIntTheThreadPeriod As Integer = 250
    Const constIntDOSWidth As Integer = 672

    Dim processDOS As New Process()
    Dim stringBatchRun As String = String.Empty

    Dim intTheDOSProcessStartedInThread As Integer = 0
    Dim threadForDOS As New Threading.Thread(AddressOf threadForDOSSub)

    Dim stringManuallyExitedMenuOption As String = "None."
    Dim stringUncompletedMenuOption As String = "None."

    Dim threadSfcAndDismRunCheck As New Threading.Thread(AddressOf CheckSfcAndDismInAThread)
    Dim iCounter As Integer = 0
    Dim intStatusOfSfcAndDism As Integer = 0
    Delegate Sub InvokeDelegate()
    Dim intPreviousSfcAndDismStatus As Integer = 0
    Dim boolRealSelectionStarted As Boolean = False

    Dim isElevated As Boolean = False

    Private Sub RepairMainForm_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Dim intStartX As Integer = 0
        Dim intStartWidth As Integer = 0

        Dim identity = WindowsIdentity.GetCurrent()
        Dim principal = New WindowsPrincipal(identity)

        isElevated = principal.IsInRole(WindowsBuiltInRole.Administrator)
        If isElevated = False Then
            MessageBox.Show("This application must be run as administrator.", "Repair : Administrator", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Close()
        End If

        'Calculate initial X and width
        intStartWidth = My.Computer.Screen.Bounds.Size.Width
        If intStartWidth > 800 Then
            intStartX = constIntDOSWidth
            intStartWidth -= constIntDOSWidth
        Else
            intStartX = intStartWidth / 2
            intStartWidth = intStartX
        End If

        'Resize the form : Can be done in load
        StartPosition = FormStartPosition.Manual
        Location = New Point(intStartX, 0)
        Size = New Size(intStartWidth, My.Computer.Screen.Bounds.Size.Height)

        'Resize the controls
        ResizeAndPosition()

        'Read the files for the initial information for the Uncompleted and Exited texts from previous runs
        'DoesRun.txt is not shared here
        'If File.Exists("DoesRun.txt") = True Then
        '    File.SetAttributes("DoesRun.txt", FileAttributes.Normal)
        '    Dim objStreamDoesRunFile As Stream = New FileStream("DoesRun.txt", FileMode.Open, FileAccess.Read, FileShare.ReadWrite)
        '    File.SetAttributes("DoesRun.txt", FileAttributes.Normal)
        '    If objStreamDoesRunFile.ReadByte() = 89 Then
        '        If File.Exists("DoesRunUncompleted.txt") = True Then
        '            Dim stringUncompletedInitial As String = String.Empty
        '            stringUncompletedInitial = File.ReadAllText("DoesRunUncompleted.txt")
        '            If String.IsNullOrEmpty(stringUncompletedInitial) = False Then
        '                intPreviousSfcAndDismStatus = 10
        '                UncompletedText.Text = stringUncompletedInitial
        '                UncompletedText.BackColor = Color.FromArgb(192, 0, 0)
        '            End If
        '        End If
        '    End If
        '    objStreamDoesRunFile.Close()
        'End If

        If File.Exists("DoesRun.txt") = True Then
            Dim stringInitialUncompleted As String = String.Empty
            stringInitialUncompleted = File.ReadAllText("DoesRun.txt")
            If String.IsNullOrEmpty(stringInitialUncompleted) = False Then
                stringInitialUncompleted = stringInitialUncompleted.Replace(vbCr, "").Replace(vbLf, "")
                If String.IsNullOrEmpty(stringInitialUncompleted) = False Then
                    stringInitialUncompleted = stringInitialUncompleted.Trim()
                    If String.IsNullOrEmpty(stringInitialUncompleted) = False Then
                        If stringInitialUncompleted = "Yes" Then
                            intPreviousSfcAndDismStatus = 10
                            UncompletedText.BackColor = Color.FromArgb(192, 0, 0)
                            StatusText.BackColor = Color.FromArgb(0, 192, 0)
                            If File.Exists("DoesRunUncompleted.txt") = True Then
                                Dim stringUncompletedInitial As String = String.Empty
                                stringUncompletedInitial = File.ReadAllText("DoesRunUncompleted.txt")
                                If String.IsNullOrEmpty(stringUncompletedInitial) = False Then
                                    stringUncompletedInitial = stringUncompletedInitial.Trim()
                                    If String.IsNullOrEmpty(stringUncompletedInitial) = False Then
                                        UncompletedText.Text = stringUncompletedInitial
                                        StatusText.Text = stringUncompletedInitial & " may have been incorrectly closed."
                                    Else
                                        UncompletedText.Text = "Unidentified."
                                        StatusText.Text = "An unidentified menu selection may have been incorrectly closed."
                                    End If
                                Else
                                    UncompletedText.Text = "Unidentified."
                                    StatusText.Text = "An unidentified menu selection may have been incorrectly closed."
                                End If
                            Else
                                UncompletedText.Text = "Unidentified."
                                StatusText.Text = "An unidentified menu selection may have been incorrectly closed."
                            End If
                        End If
                    End If
                End If
            End If
        End If

        If File.Exists("DoesRunExited.txt") = True Then
            intTheDOSProcessStartedInThread = 2
            intPreviousSfcAndDismStatus += 20
            ExitedText.BackColor = Color.FromArgb(192, 0, 0)
            Dim stringExited As String = String.Empty
            stringExited = File.ReadAllText("DoesRunExited.txt")
            If String.IsNullOrEmpty(stringExited) = False Then
                stringExited = stringExited.Trim()
                If String.IsNullOrEmpty(stringExited) = False Then
                    ExitedText.Text = stringExited
                Else
                    ExitedText.Text = "Unidentified."
                End If
            Else
                ExitedText.Text = "Unidentified."
            End If
        End If

        'Display an welcome text in the description
        DescriptionText.Text = "Welcome!" & vbCrLf & vbCrLf & "Read the help file first!" & vbCrLf & vbCrLf & "This application attempts to repair a corrupt installation of Windows and uses the Microsoft Command Prompt utilities SFC and DISM." & vbCrLf & vbCrLf & "To wrap DISM commands with SFC /SCANNOW has been one of the strategies used to attempt this repair. Also, many different DISM commands have been used, some of which affect the current Windows installation, such as the superseded and reset base DISM commands. These remove old Windows component downloads as well as point Windows to use the most recent components." & vbCrLf & vbCrLf & "Therefore, to read the help of this application before any attempt to repair Windows is very important as well as to find more information from the Internet." & vbCrLf & vbCrLf & "Read the help of this application, find more information on the Interenet and then continue!" & vbCrLf & vbCrLf & "Wait for the full completion of any of the menu selections, do not close the Command Prompt manually and do not exit the application before the full completion."

        'Get the correct path for the system. There are two runas.exe files and two cmd.exe files. One of each in C:\Windows\System32\,
        'the other one of each in C: \Windows\SysWOW64\, i. e. one of them 32 bit, the other 64
        'Dim NativeDir = Path.Combine(Environment.GetEnvironmentVariable("windir"), "sysnative")
        'Dim ExePathRunAs = Path.Combine(NativeDir, "runas.exe")
        'Dim ExePathCMD = Path.Combine(NativeDir, "cmd.exe")
        'These do not seem to work, however. Depends on the application too, whether 32 or 64 bit. Best Visual Studio to decide.

        processDOS.StartInfo.Verb = "runas" ' ( ExePathRunAs ) Run as Administrator. This is done in the manifest and may not be necessary again. Just in cases.
        processDOS.StartInfo.FileName = "cmd" '( ExePathCMD ) Starts a CMD window
        processDOS.EnableRaisingEvents = True
        'processDOS.StartInfo.RedirectStandardInput = True 'May not be used
        'processDOS.StartInfo.RedirectStandardOutput = True
        'processDOS.StartInfo.RedirectStandardError = True
        processDOS.StartInfo.UseShellExecute = True 'Must be False to redirect
        'processDOS.StartInfo.CreateNoWindow = True
        processDOS.StartInfo.WindowStyle = ProcessWindowStyle.Maximized 'Just in Cases

        'Show a welcome message. Must be before the Command Prompt to be in focus and not covert.
        MessageBox.Show("Welcome to Repair!" & vbCrLf & vbCrLf & "Repair uses Microsoft Command Promt utilities SFC and DISM to attempt to repair a corrupt installation of Windows." & vbCrLf & vbCrLf & "The best way to use this application is to never close neither any Command Prompt windows manually nor this application before the completion of any current menu selection, thus, to wait for the started sequence ( batch ) of commands to fully complete." & vbCrLf & vbCrLf & "SFC and DISM may continue to run in the background even after this application or the Command Prompt window, on which SFC and DISM are run, is manually closed. SFC and DISM may invoke other processes which continue to run in the background and cannot be closed when the Command Prompt window or this application is closed. Thus, manually closed Command Prompt windows or application may not be able to close the already started processes or the processes started by them. The Command Prompt window displays the true status of SFC and DISM." & vbCrLf & vbCrLf & "This application is a tool which attempts to repair a corrupt installation of Windows on the computer on which this application is run. To accomplish this, this application automates the well known Microsoft Command Prompt utilities called SFC and DISM designed by Microsoft to be run on a Command Prompt window. The best way to display the status and other information of these utilities is, therefore, to display a Command Prompt where the utilities run and display their original information." & vbCrLf & vbCrLf & "Do read the help of this application first!", "Repair : Welcome!", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

        'While Command Prompt is open, load is slowed and the initial show of non resized form is not visible. Best be here to slow the load.
        'When this is in load, the two windows start simultaneously. When in shown, the main form is loaded before the Command prompt.
        'Also, the start of the thread takes very long.
        'Start Command Prompt. Make a batch file to display a welcome message.
        stringBatchRun = "@ECHO OFF" & vbCrLf & "CLS" & vbCrLf & "ECHO **********************& ECHO * Welcome to Repair! *& ECHO **********************" & vbCrLf & "@ECHO ON"
        File.WriteAllText("RunBatch.bat", stringBatchRun)
        processDOS.StartInfo.Arguments = "/K " & "RunBatch.bat"
        processDOS.Start()
        processDOS.Close()

    End Sub

    Private Sub RepairMainForm_Shown(sender As Object, e As EventArgs) Handles MyBase.Shown

        'Display the light bulb
        LightShine(intStatusOfSfcAndDism)

        'The thread must be started here, after the load, to be able to paint
        'Start the thread which checks whether SFC and or DISM run.
        threadSfcAndDismRunCheck.Start()

    End Sub

    Private Sub RunAllToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles RunAllToolStripMenuItem.Click

        'Check whether SFC or DISM run
        If AskForSFCOrDISMRun() = True Then
            Exit Sub
        End If

        'Ask to Continue
        If AskToContinue() <> DialogResult.Yes Then
            Exit Sub
        End If

        'Close all command prompts
        CloseAllCMD()

        'Display
        MenuSelectionText.Text = "Repair ➔ Run All"
        'stringUncompletedMenuOption = MenuSelectionText.Text
        DescriptionText.Text = "This menu selection runs a few DISM commands surrounded by SFC /SCANNOW." _
            & vbCrLf & vbCrLf &
            "SFC /SCANNOW scans the Windows components ( files ), may find corrupted files and may attempt to download and install the non corrupted equivalents of the corrupted files. In some cases, SCF /SCANNOW may only download the necessary files to be installed after a restart, in other cases, SFC /SCANNOW may schedule the files to be downloaded thereafter." _
            & vbCrLf & vbCrLf &
            "In some cases, to call DISM after and before SFC /SCANNOW may trigger a file download, installation or schedule for a download and installation." _
            & vbCrLf & vbCrLf &
            "Although SFC and DISM may be pointed towards an installation CD, Repair heavily relies on the possibility to find the newest correct and non corrupted versions of corrupted files from the Microsoft web sites. Thus, the computer must be connected to the Internet." _
            & vbCrLf & vbCrLf &
            "The DISM commands run with this menu selection are :" _
            & vbCrLf & vbCrLf &
            "DISM /Online /Cleanup-Image /SPSuperseded" _
            & vbCrLf &
            "DISM /Online /Cleanup-Image /StartComponentCleanup /ResetBase" _
            & vbCrLf &
            "DISM /Online /Cleanup-Image /StartComponentCleanup" _
            & vbCrLf &
            "DISM / Online / Cleanup-Image / ScanHealth" _
            & vbCrLf &
            "DISM /Online /Cleanup-Image /RestoreHealth" _
            & vbCrLf & vbCrLf &
            "DISM /Online /Cleanup-Image /SPSuperseded attempts to delete any saved old versions of component updates. After this DISM command, Windows cannot be returned to any old updates and the present updates are the only ones available." _
            & vbCrLf & vbCrLf &
            "DISM /Online /Cleanup-Image /StartComponentCleanup /ResetBase again attempts to point Windows to the newest updates in case this has not been done. Thus, the newest updates become the base of Windows. Another cleanup of corrupt components ( files ) may be attempted." _
            & vbCrLf & vbCrLf &
            "DISM /Online /Cleanup-Image /StartComponentCleanup again attempts to delete and replace all corrupted components ( files )." _
            & vbCrLf & vbCrLf &
            "DISM / Online / Cleanup-Image / ScanHealth scans the general condition of all Windows updates and attempts to find any problems." _
            & vbCrLf & vbCrLf &
            "DISM /Online /Cleanup-Image /RestoreHealth attempts to repair any problems with all Windows updates." _
            & vbCrLf & vbCrLf &
            "Wait for the full completion of any of the menu selections, do not close the Command Prompt manually and do not exit the application before the full completion."
        'Make a batch file of all commands and run the batch file with an option for the prompt to stay
        stringBatchRun = "ECHO Yes>DoesRun.txt" & vbCrLf & "@ECHO ON" & vbCrLf & "SFC /SCANNOW" & vbCrLf & "DISM /Online /Cleanup-Image /SPSuperseded" & vbCrLf & "SFC /SCANNOW" & vbCrLf & "DISM /Online /Cleanup-Image /StartComponentCleanup /ResetBase" & vbCrLf & "SFC /SCANNOW" & vbCrLf & "DISM /Online /Cleanup-Image /StartComponentCleanup" & vbCrLf & "SFC /SCANNOW" & vbCrLf & "DISM /Online /Cleanup-Image /ScanHealth" & vbCrLf & "SFC /SCANNOW" & vbCrLf & "DISM /Online /Cleanup-Image /RestoreHealth" & vbCrLf & "SFC /SCANNOW" & vbCrLf & "ECHO No>DoesRun.txt"
        MainText.Text = stringBatchRun
        File.WriteAllText("RunBatch.bat", stringBatchRun)
        RunDOS("/K", "RunBatch.bat")

        'Indicated the conditions are not the initial ones
        boolRealSelectionStarted = True

    End Sub

    Private Sub ScanCleanAndReapirWithSFCAndDISMToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ScanCleanAndReapirWithSFCAndDISMToolStripMenuItem.Click

        'Check whether SFC or DISM run
        If AskForSFCOrDISMRun() = True Then
            Exit Sub
        End If

        'Ask to Continue
        If AskToContinue() <> DialogResult.Yes Then
            Exit Sub
        End If

        'Close all command prompts
        CloseAllCMD()

        'Display
        MenuSelectionText.Text = "Repair ➔ Scan, Clean and Repair with SFC and DISM"
        'stringUncompletedMenuOption = MenuSelectionText.Text
        DescriptionText.Text = "This menu selection runs a few DISM commands surrounded by SFC /SCANNOW." _
           & vbCrLf & vbCrLf &
            "SFC /SCANNOW scans the Windows components ( files ), may find corrupted files and may attempt to download and install the non corrupted equivalents of the corrupted files. In some cases, SCF /SCANNOW may only download the necessary files to be installed after a restart, in other cases, SFC /SCANNOW may schedule the files to be downloaded thereafter." _
            & vbCrLf & vbCrLf &
            "In some cases, to call DISM after and before SFC /SCANNOW may trigger a file download, installation or schedule for a download and installation." _
            & vbCrLf & vbCrLf &
            "Although SFC and DISM may be pointed towards an installation CD, Repair heavily relies on the possibility to find the newest correct and non corrupted versions of corrupted files from the Microsoft web sites. Thus, the computer must be connected to the Internet." _
            & vbCrLf & vbCrLf &
            "The DISM commands run with this menu selection are :" _
            & vbCrLf & vbCrLf &
            "DISM / Online / Cleanup-Image / ScanHealth" _
            & vbCrLf &
            "DISM /Online /Cleanup-Image /StartComponentCleanup" _
            & vbCrLf &
            "DISM /Online /Cleanup-Image /RestoreHealth" _
            & vbCrLf & vbCrLf &
            "DISM / Online / Cleanup-Image / ScanHealth scans the general condition of all Windows updates and attempts to find any problems." _
            & vbCrLf & vbCrLf &
            "DISM /Online /Cleanup-Image /StartComponentCleanup attempts to delete and replace all corrupted components ( files )." _
            & vbCrLf & vbCrLf &
            "DISM /Online /Cleanup-Image /RestoreHealth attempts to repair any problems with all Windows updates." _
            & vbCrLf & vbCrLf &
            "Wait for the full completion of any of the menu selections, do not close the Command Prompt manually and do not exit the application before the full completion."
        'Make a batch file of all commands and run the batch file with an option for the prompt to stay
        stringBatchRun = "ECHO Yes>DoesRun.txt" & vbCrLf & "@ECHO ON" & vbCrLf & "SFC /SCANNOW" & vbCrLf & "DISM /Online /Cleanup-Image /ScanHealth" & vbCrLf & "SFC /SCANNOW" & vbCrLf & "DISM /Online /Cleanup-Image /StartComponentCleanup" & vbCrLf & "SFC /SCANNOW" & vbCrLf & "DISM /Online /Cleanup-Image /RestoreHealth" & vbCrLf & "SFC /SCANNOW" & vbCrLf & "ECHO No>DoesRun.txt"
        MainText.Text = stringBatchRun
        File.WriteAllText("RunBatch.bat", stringBatchRun)
        RunDOS("/K", "RunBatch.bat")

        'Indicated the conditions are not the initial ones
        boolRealSelectionStarted = True

    End Sub

    Private Sub ScanAndCleanWithDISMRepairWithSFCOnlyToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ScanAndCleanWithDISMRepairWithSFCOnlyToolStripMenuItem.Click

        'Check whether SFC or DISM run
        If AskForSFCOrDISMRun() = True Then
            Exit Sub
        End If

        'Ask to Continue
        If AskToContinue() <> DialogResult.Yes Then
            Exit Sub
        End If

        'Close all command prompts
        CloseAllCMD()

        'Display
        MenuSelectionText.Text = "Repair ➔ Scan and Clean with DISM, Repair with SFC Only"
        'stringUncompletedMenuOption = MenuSelectionText.Text
        DescriptionText.Text = "This menu selection runs a few DISM commands surrounded by SFC /SCANNOW." _
            & vbCrLf & vbCrLf &
            "SFC /SCANNOW scans the Windows components ( files ), may find corrupted files and may attempt to download and install the non corrupted equivalents of the corrupted files. In some cases, SCF /SCANNOW may only download the necessary files to be installed after a restart, in other cases, SFC /SCANNOW may schedule the files to be downloaded thereafter." _
            & vbCrLf & vbCrLf &
            "In some cases, to call DISM after and before SFC /SCANNOW may trigger a file download, installation or schedule for a download and installation." _
            & vbCrLf & vbCrLf &
            "Although SFC and DISM may be pointed towards an installation CD, Repair heavily relies on the possibility to find the newest correct and non corrupted versions of corrupted files from the Microsoft web sites. Thus, the computer must be connected to the Internet." _
            & vbCrLf & vbCrLf &
            "The DISM commands run with this menu selection are :" _
            & vbCrLf & vbCrLf &
            "DISM / Online / Cleanup-Image / ScanHealth" _
            & vbCrLf &
            "DISM /Online /Cleanup-Image /StartComponentCleanup" _
            & vbCrLf & vbCrLf &
            "DISM / Online / Cleanup-Image / ScanHealth scans the general condition of all Windows updates and attempts to find any problems." _
            & vbCrLf & vbCrLf &
            "DISM /Online /Cleanup-Image /StartComponentCleanup attempts to delete and replace all corrupted components ( files )." _
            & vbCrLf & vbCrLf &
            "Wait for the full completion of any of the menu selections, do not close the Command Prompt manually and do not exit the application before the full completion."
        'Make a batch file of all commands and run the batch file with an option for the prompt to stay
        stringBatchRun = "ECHO Yes>DoesRun.txt" & vbCrLf & "@ECHO ON" & vbCrLf & "SFC /SCANNOW" & vbCrLf & "DISM /Online /Cleanup-Image /ScanHealth" & vbCrLf & "SFC /SCANNOW" & vbCrLf & "DISM /Online /Cleanup-Image /StartComponentCleanup" & vbCrLf & "SFC /SCANNOW" & vbCrLf & "ECHO No>DoesRun.txt"
        MainText.Text = stringBatchRun
        File.WriteAllText("RunBatch.bat", stringBatchRun)
        RunDOS("/K", "RunBatch.bat")

        'Indicated the conditions are not the initial ones
        boolRealSelectionStarted = True

    End Sub

    Private Sub ScanAndRepairWithSFCOnlyToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ScanAndRepairWithSFCOnlyToolStripMenuItem.Click

        'Check whether SFC or DISM run
        If AskForSFCOrDISMRun() = True Then
            Exit Sub
        End If

        'Ask to Continue
        If AskToContinue() <> DialogResult.Yes Then
            Exit Sub
        End If

        'Close all command prompts
        CloseAllCMD()

        'Display
        MenuSelectionText.Text = "Repair ➔ Scan and Repair with SFC Only"
        'stringUncompletedMenuOption = MenuSelectionText.Text
        DescriptionText.Text = "This menu selection runs SFC /SCANNOW." _
            & vbCrLf & vbCrLf &
            "SFC /SCANNOW scans the Windows components ( files ), may find corrupted files and may attempt to download and install the non corrupted equivalents of the corrupted files. In some cases, SCF /SCANNOW may only download the necessary files to be installed after a restart, in other cases, SFC /SCANNOW may schedule the files to be downloaded thereafter." _
            & vbCrLf & vbCrLf &
            "Although SFC may be pointed towards an installation CD, Repair heavily relies on the possibility to find the newest correct and non corrupted versions of corrupted files from the Microsoft web sites. Thus, the computer must be connected to the Internet." _
            & vbCrLf & vbCrLf &
            "Wait for the full completion of any of the menu selections, do not close the Command Prompt manually and do not exit the application before the full completion."
        'Make a batch file of all commands and run the batch file with an option for the prompt to stay
        stringBatchRun = "ECHO Yes>DoesRun.txt" & vbCrLf & "@ECHO ON" & vbCrLf & "SFC /SCANNOW" & vbCrLf & "ECHO No>DoesRun.txt"
        MainText.Text = stringBatchRun
        File.WriteAllText("RunBatch.bat", stringBatchRun)
        RunDOS("/K", "RunBatch.bat")

        'Indicated the conditions are not the initial ones
        boolRealSelectionStarted = True

    End Sub

    Private Sub ResetBaseOnlyToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ResetBaseOnlyToolStripMenuItem.Click

        'Check whether SFC or DISM run
        If AskForSFCOrDISMRun() = True Then
            Exit Sub
        End If

        'Ask to Continue
        If AskToContinue() <> DialogResult.Yes Then
            Exit Sub
        End If

        'Close all command prompts
        CloseAllCMD()

        'Display
        MenuSelectionText.Text = "Repair ➔ Reset Base Only"
        'stringUncompletedMenuOption = MenuSelectionText.Text
        DescriptionText.Text = "This menu selection runs a DISM command surrounded by SFC /SCANNOW." _
           & vbCrLf & vbCrLf &
            "SFC /SCANNOW scans the Windows components ( files ), may find corrupted files and may attempt to download and install the non corrupted equivalents of the corrupted files. In some cases, SCF /SCANNOW may only download the necessary files to be installed after a restart, in other cases, SFC /SCANNOW may schedule the files to be downloaded thereafter." _
            & vbCrLf & vbCrLf &
            "In some cases, to call DISM after and before SFC /SCANNOW may trigger a file download, installation or schedule for a download and installation." _
            & vbCrLf & vbCrLf &
            "Although SFC and DISM may be pointed towards an installation CD, Repair heavily relies on the possibility to find the newest correct and non corrupted versions of corrupted files from the Microsoft web sites. Thus, the computer must be connected to the Internet." _
            & vbCrLf & vbCrLf &
            "The DISM command run with this menu selection is :" _
            & vbCrLf & vbCrLf &
            "DISM /Online /Cleanup-Image /StartComponentCleanup /ResetBase" _
            & vbCrLf & vbCrLf &
            "DISM /Online /Cleanup-Image /StartComponentCleanup /ResetBase attempts to point Windows to the newest updates in case this has not been done. Thus, the newest updates become the base of Windows. Another cleanup of corrupt components ( files ) may be attempted." _
            & vbCrLf & vbCrLf &
            "Wait for the full completion of any of the menu selections, do not close the Command Prompt manually and do not exit the application before the full completion."
        'Make a batch file of all commands and run the batch file with an option for the prompt to stay
        stringBatchRun = "ECHO Yes>DoesRun.txt" & vbCrLf & "@ECHO ON" & vbCrLf & "SFC /SCANNOW" & vbCrLf & "DISM /Online /Cleanup-Image /StartComponentCleanup /ResetBase" & vbCrLf & "SFC /SCANNOW" & vbCrLf & "ECHO No>DoesRun.txt"
        MainText.Text = stringBatchRun
        File.WriteAllText("RunBatch.bat", stringBatchRun)
        RunDOS("/K", "RunBatch.bat")

        'Indicated the conditions are not the initial ones
        boolRealSelectionStarted = True

    End Sub

    Private Sub SupersededOnlyToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SupersededOnlyToolStripMenuItem.Click

        'Check whether SFC or DISM run
        If AskForSFCOrDISMRun() = True Then
            Exit Sub
        End If

        'Ask to Continue
        If AskToContinue() <> DialogResult.Yes Then
            Exit Sub
        End If

        'Close all command prompts
        CloseAllCMD()

        'Display
        MenuSelectionText.Text = "Repair ➔ Superseded Only"
        'stringUncompletedMenuOption = MenuSelectionText.Text
        DescriptionText.Text = "This menu selection runs a DISM command surrounded by SFC /SCANNOW." _
            & vbCrLf & vbCrLf &
            "SFC /SCANNOW scans the Windows components ( files ), may find corrupted files and may attempt to download and install the non corrupted equivalents of the corrupted files. In some cases, SCF /SCANNOW may only download the necessary files to be installed after a restart, in other cases, SFC /SCANNOW may schedule the files to be downloaded thereafter." _
            & vbCrLf & vbCrLf &
            "In some cases, to call DISM after and before SFC /SCANNOW may trigger a file download, installation or schedule for a download and installation." _
            & vbCrLf & vbCrLf &
            "Although SFC and DISM may be pointed towards an installation CD, Repair heavily relies on the possibility to find the newest correct and non corrupted versions of corrupted files from the Microsoft web sites. Thus, the computer must be connected to the Internet." _
            & vbCrLf & vbCrLf &
            "The DISM command run with this menu selection is :" _
            & vbCrLf & vbCrLf &
            "DISM /Online /Cleanup-Image /SPSuperseded" _
            & vbCrLf & vbCrLf &
            "DISM /Online /Cleanup-Image /SPSuperseded attempts to delete any saved old versions of component updates. After this DISM command, Windows cannot be returned to any old updates and the present updates are the only ones available." _
            & vbCrLf & vbCrLf &
            "Wait for the full completion of any of the menu selections, do not close the Command Prompt manually and do not exit the application before the full completion."
        'Make a batch file of all commands and run the batch file with an option for the prompt to stay
        stringBatchRun = "ECHO Yes>DoesRun.txt" & vbCrLf & "@ECHO ON" & vbCrLf & "SFC /SCANNOW" & vbCrLf & "DISM /Online /Cleanup-Image /SPSuperseded" & vbCrLf & "SFC /SCANNOW" & vbCrLf & "ECHO No>DoesRun.txt"
        MainText.Text = stringBatchRun
        File.WriteAllText("RunBatch.bat", stringBatchRun)
        RunDOS("/K", "RunBatch.bat")

        'Indicated the conditions are not the initial ones
        boolRealSelectionStarted = True

    End Sub

    'Necessary in order to switch the monitors off
    Const WM_SYSCOMMAND As Integer = &H112
    Const SC_MONITORPOWER As Integer = &HF170
    <DllImport("user32.dll")>
    Private Shared Function SendMessage(hWnd As Integer, hMsg As Integer, wParam As Integer, lParam As Integer) As Integer
    End Function
    'Necessary in order to disallow the mouse
    Private Declare Function BlockInput Lib "user32" Alias "BlockInput" (ByVal fBlock As Integer) As Integer
    Private Declare Function ShowCursor Lib "user32" (ByVal lShow As Long) As Long

    Private Sub MonitorsOffToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles MonitorsOffToolStripMenuItem.Click
        SendMessage(Handle.ToInt32(), WM_SYSCOMMAND, SC_MONITORPOWER, 2) 'Switch all monitors off
        BlockInput(1) 'Disallow the mouse
        ShowCursor(0) 'Do not show the cursor
        Threading.Thread.Sleep(2000)
        BlockInput(0) 'Reallow the mouse
        ShowCursor(1) 'Show the cursor
    End Sub

    Private Sub SleepToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SleepToolStripMenuItem.Click

        Dim processLog As New Process()

        Dim stringMainTextBackUp As String = String.Empty
        Dim stringMenuSelectionTextBackUp As String = String.Empty
        Dim stringDescriptionTextBackUp As String = String.Empty

        stringMainTextBackUp = MainText.Text
        stringMenuSelectionTextBackUp = MenuSelectionText.Text
        stringDescriptionTextBackUp = DescriptionText.Text

        MainText.Text = "powercfg /hibernate off" & vbCrLf & "rundll32.exe powrprof.dll,SetSuspendState 0,1,0" & vbCrLf & "powercfg /hibernate off"
        MenuSelectionText.Text = "Repair ➔ Switch Off ➔ Sleep"
        DescriptionText.Text = "This menu selection will make the computer sleep."

        If MessageBox.Show(PrepareStringForShutdown(1), "Repair : Sleep", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then

            MainText.Text = stringMainTextBackUp
            MenuSelectionText.Text = stringMenuSelectionTextBackUp
            DescriptionText.Text = stringDescriptionTextBackUp

            processLog.EnableRaisingEvents = True
            processLog.StartInfo.UseShellExecute = True 'Must be False to redirect
            processLog.StartInfo.WindowStyle = ProcessWindowStyle.Maximized 'Just in Cases

            processLog.StartInfo.FileName = "powercfg" '( ExePathCMD ) Starts a CMD window
            processLog.StartInfo.Arguments = "/hibernate off"
            processLog.Start()
            processLog.Close()

            processLog.StartInfo.FileName = "rundll32.exe" '( ExePathCMD ) Starts a CMD window
            processLog.StartInfo.Arguments = "powrprof.dll,SetSuspendState 0,1,0"
            processLog.Start()
            processLog.Close()

            processLog.StartInfo.FileName = "powercfg" '( ExePathCMD ) Starts a CMD window
            processLog.StartInfo.Arguments = "/hibernate on"
            processLog.Start()
            processLog.Close()

        End If

        MainText.Text = stringMainTextBackUp
        MenuSelectionText.Text = stringMenuSelectionTextBackUp
        DescriptionText.Text = stringDescriptionTextBackUp

    End Sub

    Private Sub LogOffToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles LogOffToolStripMenuItem.Click

        Dim processLog As New Process()

        Dim stringMainTextBackUp As String = String.Empty
        Dim stringMenuSelectionTextBackUp As String = String.Empty
        Dim stringDescriptionTextBackUp As String = String.Empty

        stringMainTextBackUp = MainText.Text
        stringMenuSelectionTextBackUp = MenuSelectionText.Text
        stringDescriptionTextBackUp = DescriptionText.Text

        MainText.Text = "shutdown.exe /l"
        MenuSelectionText.Text = "Repair ➔ Switch Off ➔ Log Off"
        DescriptionText.Text = "This menu selection will make the computer log off."

        If MessageBox.Show(PrepareStringForShutdown(2), "Repair : Log Off", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then

            MainText.Text = stringMainTextBackUp
            MenuSelectionText.Text = stringMenuSelectionTextBackUp
            DescriptionText.Text = stringDescriptionTextBackUp

            processLog.StartInfo.FileName = "shutdown.exe" '( ExePathCMD ) Starts a CMD window
            processLog.StartInfo.Arguments = "/l"
            processLog.EnableRaisingEvents = True
            processLog.StartInfo.UseShellExecute = True 'Must be False to redirect
            processLog.StartInfo.WindowStyle = ProcessWindowStyle.Maximized 'Just in Cases

            processLog.Start()
            processLog.Close()

        End If

        MainText.Text = stringMainTextBackUp
        MenuSelectionText.Text = stringMenuSelectionTextBackUp
        DescriptionText.Text = stringDescriptionTextBackUp

    End Sub

    Private Sub HibernateToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles HibernateToolStripMenuItem.Click

        Dim processLog As New Process()

        Dim stringMainTextBackUp As String = String.Empty
        Dim stringMenuSelectionTextBackUp As String = String.Empty
        Dim stringDescriptionTextBackUp As String = String.Empty

        processLog.StartInfo.FileName = "powercfg" '( ExePathCMD ) Starts a CMD window
        processLog.StartInfo.Arguments = "/hibernate on"
        processLog.Start()
        processLog.Close()

        stringMainTextBackUp = MainText.Text
        stringMenuSelectionTextBackUp = MenuSelectionText.Text
        stringDescriptionTextBackUp = DescriptionText.Text

        MainText.Text = "shutdown.exe /h"
        MenuSelectionText.Text = "Repair ➔ Switch Off ➔ Hibernate"
        DescriptionText.Text = "This menu selection will make the computer hibernate."

        If MessageBox.Show(PrepareStringForShutdown(3), "Repair : Hibernate", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then

            MainText.Text = stringMainTextBackUp
            MenuSelectionText.Text = stringMenuSelectionTextBackUp
            DescriptionText.Text = stringDescriptionTextBackUp

            processLog.StartInfo.FileName = "shutdown.exe" '( ExePathCMD ) Starts a CMD window
            processLog.StartInfo.Arguments = "/h"
            processLog.EnableRaisingEvents = True
            processLog.StartInfo.UseShellExecute = True 'Must be False to redirect
            processLog.StartInfo.WindowStyle = ProcessWindowStyle.Maximized 'Just in Cases

            processLog.Start()
            processLog.Close()

        End If

        MainText.Text = stringMainTextBackUp
        MenuSelectionText.Text = stringMenuSelectionTextBackUp
        DescriptionText.Text = stringDescriptionTextBackUp

    End Sub

    Private Sub RestartToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles RestartToolStripMenuItem.Click

        Dim processLog As New Process()

        Dim stringMainTextBackUp As String = String.Empty
        Dim stringMenuSelectionTextBackUp As String = String.Empty
        Dim stringDescriptionTextBackUp As String = String.Empty

        stringMainTextBackUp = MainText.Text
        stringMenuSelectionTextBackUp = MenuSelectionText.Text
        stringDescriptionTextBackUp = DescriptionText.Text

        MainText.Text = "shutdown.exe /r /t 00"
        MenuSelectionText.Text = "Repair ➔ Switch Off ➔ Restart"
        DescriptionText.Text = "This menu selection will restart the computer."

        If MessageBox.Show(PrepareStringForShutdown(4), "Repair : Restart", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then

            BeforeExit()

            processLog.StartInfo.FileName = "shutdown.exe" '( ExePathCMD ) Starts a CMD window
            processLog.StartInfo.Arguments = "/r /t 00"
            processLog.EnableRaisingEvents = True
            processLog.StartInfo.UseShellExecute = True 'Must be False to redirect
            processLog.StartInfo.WindowStyle = ProcessWindowStyle.Maximized 'Just in Cases

            processLog.Start()
            processLog.Close()

        Else

            MainText.Text = stringMainTextBackUp
            MenuSelectionText.Text = stringMenuSelectionTextBackUp
            DescriptionText.Text = stringDescriptionTextBackUp

        End If

    End Sub

    Private Sub ShutdownToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ShutdownToolStripMenuItem.Click

        Dim processLog As New Process()

        Dim stringMainTextBackUp As String = String.Empty
        Dim stringMenuSelectionTextBackUp As String = String.Empty
        Dim stringDescriptionTextBackUp As String = String.Empty

        stringMainTextBackUp = MainText.Text
        stringMenuSelectionTextBackUp = MenuSelectionText.Text
        stringDescriptionTextBackUp = DescriptionText.Text

        MainText.Text = "shutdown.exe /s /t 00"
        MenuSelectionText.Text = "Repair ➔ Switch Off ➔ Shutdown"
        DescriptionText.Text = "This menu selection will shut the computer down."

        If MessageBox.Show(PrepareStringForShutdown(5), "Repair : Shutdown", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then

            BeforeExit()

            processLog.StartInfo.FileName = "shutdown.exe" '( ExePathCMD ) Starts a CMD window
            processLog.StartInfo.Arguments = "/s /t 00"
            processLog.EnableRaisingEvents = True
            processLog.StartInfo.UseShellExecute = True 'Must be False to redirect
            processLog.StartInfo.WindowStyle = ProcessWindowStyle.Maximized 'Just in Cases

            processLog.Start()
            processLog.Close()

        Else

            MainText.Text = stringMainTextBackUp
            MenuSelectionText.Text = stringMenuSelectionTextBackUp
            DescriptionText.Text = stringDescriptionTextBackUp

        End If

    End Sub

    Private Function PrepareStringForShutdown(intWhatShutdown As Integer) As String

        Dim stringToExit As String = String.Empty

        Dim intTempStatus As Integer = 0
        intTempStatus = DoAnySFCOrDISMRunNow()
        If intTempStatus >= 20 Then
            intTempStatus -= 20
        End If
        Select Case intTempStatus
            Case 0
                stringToExit = ""
            Case 1
                stringToExit = "Attention : SFC still runs now." & vbCrLf & vbCrLf
            Case 2
                stringToExit = "Attention : DISM still runs now." & vbCrLf & vbCrLf
            Case 3
                stringToExit = "Attention : SFC and DISM still run now." & vbCrLf & vbCrLf
            Case 10
                If boolRealSelectionStarted = True Then
                    stringToExit = "Attention : The menu selection still may still run now or has been incorrectly closed." & vbCrLf & vbCrLf
                Else
                    stringToExit = "Attention : A menu selection may still run now or has been incorrectly closed." & vbCrLf & vbCrLf
                End If
            Case 11
                stringToExit = "Attention : The menu selection and SFC still run now." & vbCrLf & vbCrLf
            Case 12
                stringToExit = "Attention : The menu selection and DISM still run now." & vbCrLf & vbCrLf
            Case 13
                stringToExit = "Attention : The menu selection, SFC and DISM still run now." & vbCrLf & vbCrLf
            Case Else
                stringToExit = "Attention : There has been an unexpected error when attempted to find out whether SFC and or DISM still run now but this error will be ignored." & vbCrLf & vbCrLf
        End Select

        Select Case intWhatShutdown
            Case 0
                PrepareStringForShutdown = "Attention : All monitors will be switched off." & vbCrLf & vbCrLf & stringToExit & "Repair will continue to work while the monitors are switched off." & vbCrLf & vbCrLf & "Do you really want to switch all monitors off?"
            Case 1
                PrepareStringForShutdown = "Attention : The computer will sleep." & vbCrLf & vbCrLf & stringToExit & "Repair will not continue to work in the background while the computer sleeps." & vbCrLf & vbCrLf & "Save all your work before the computer sleeps." & vbCrLf & vbCrLf & "Do you really want the computer to sleep?"
            Case 2
                PrepareStringForShutdown = "Attention : The computer will log off." & vbCrLf & vbCrLf & stringToExit & "Repair will not continue to work in the background while the computer logs off and thereafter." & vbCrLf & vbCrLf & "Save all your work before the computer logs off." & vbCrLf & vbCrLf & "Do you really want the computer to log off?"
            Case 3
                PrepareStringForShutdown = "Attention : The computer will hibernate." & vbCrLf & vbCrLf & stringToExit & "Repair will not continue to work in the background while the computer hibernates." & vbCrLf & vbCrLf & "Save all your work before the computer hibernates." & vbCrLf & vbCrLf & "Do you really want the computer to hibernate?"
            Case 4
                PrepareStringForShutdown = "Attention : The computer will restart." & vbCrLf & vbCrLf & stringToExit & "Repair will not continue to work in the background while the computer restarts and thereafter." & vbCrLf & vbCrLf & "Save all your work before the restart." & vbCrLf & vbCrLf & "Do you really want to restart the computer?"
            Case 5
                PrepareStringForShutdown = "Attention : The computer will shutdown." & vbCrLf & vbCrLf & stringToExit & "Repair will not continue to work in the background while the computer shuts down and therafter." & vbCrLf & vbCrLf & "Save all your work before the shutdown." & vbCrLf & vbCrLf & "Do you really want to shutdown the computer?"
            Case Else
                PrepareStringForShutdown = "Attention : Error with Repair ➔ Switch Off." & vbCrLf & vbCrLf & stringToExit & "There has been an unexpected error with Switch Off. Save all your work and then continue." & vbCrLf & vbCrLf & "Do you really want to continue?"
        End Select

    End Function

    Private Sub SFCLogToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles SFCLogToolStripMenuItem.Click

        Dim processLog As New Process()
        Dim stringCBSLog As String = String.Empty

        Dim stringMainTextBackUp As String = String.Empty
        Dim stringMenuSelectionTextBackUp As String = String.Empty
        Dim stringDescriptionTextBackUp As String = String.Empty

        stringMainTextBackUp = MainText.Text
        stringMenuSelectionTextBackUp = MenuSelectionText.Text
        stringDescriptionTextBackUp = DescriptionText.Text

        stringCBSLog = Environment.GetEnvironmentVariable("WINDIR") & "\Logs\CBS\CBS.log"
        MainText.Text = "notepad.exe " & stringCBSLog
        MenuSelectionText.Text = "Logs ➔ SFC"
        DescriptionText.Text = "Displays the SFC Log file in Notepad."

        If File.Exists(stringCBSLog) = False Then
            MessageBox.Show("The SFC log file " & stringCBSLog & " is not currently available." & vbCrLf & vbCrLf & "This file must become available after SFC is run.", "Repair : SFC Log File", MessageBoxButtons.OK, MessageBoxIcon.Information)
            MainText.Text = stringMainTextBackUp
            MenuSelectionText.Text = stringMenuSelectionTextBackUp
            DescriptionText.Text = stringDescriptionTextBackUp
            Exit Sub
        End If

        MessageBox.Show("The SFC log file " & stringCBSLog & " will conveniently be opened in Notepad.", "Repair : SFC Log File", MessageBoxButtons.OK, MessageBoxIcon.Information)

        processLog.StartInfo.FileName = "notepad.exe" '( ExePathCMD ) Starts a CMD window
        processLog.StartInfo.Arguments = stringCBSLog
        processLog.EnableRaisingEvents = True
        processLog.StartInfo.UseShellExecute = True 'Must be False to redirect
        processLog.StartInfo.WindowStyle = ProcessWindowStyle.Maximized 'Just in Cases

        processLog.Start()
        processLog.Close()

        MainText.Text = stringMainTextBackUp
        MenuSelectionText.Text = stringMenuSelectionTextBackUp
        DescriptionText.Text = stringDescriptionTextBackUp

    End Sub

    Private Sub DISMLogToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles DISMLogToolStripMenuItem.Click

        Dim processLog As New Process()
        Dim stringDISMLog As String = String.Empty

        Dim stringMainTextBackUp As String = String.Empty
        Dim stringMenuSelectionTextBackUp As String = String.Empty
        Dim stringDescriptionTextBackUp As String = String.Empty

        stringMainTextBackUp = MainText.Text
        stringMenuSelectionTextBackUp = MenuSelectionText.Text
        stringDescriptionTextBackUp = DescriptionText.Text

        stringDISMLog = Environment.GetEnvironmentVariable("WINDIR") & "\Logs\DISM\dism.log"
        MainText.Text = "notepad.exe " & stringDISMLog
        MenuSelectionText.Text = "Logs ➔ DISM"
        DescriptionText.Text = "Displays the DISM Log file in Notepad."

        If File.Exists(stringDISMLog) = False Then
            MessageBox.Show("The DISM log file " & stringDISMLog & " is not currently available." & vbCrLf & vbCrLf & "This file must become available after DISM is run.", "Repair : DISM Log File", MessageBoxButtons.OK, MessageBoxIcon.Information)
            MainText.Text = stringMainTextBackUp
            MenuSelectionText.Text = stringMenuSelectionTextBackUp
            DescriptionText.Text = stringDescriptionTextBackUp
            Exit Sub
        End If

        MessageBox.Show("The SFC log file " & stringDISMLog & " will conveniently be opened in Notepad.", "Repair : DISM Log File", MessageBoxButtons.OK, MessageBoxIcon.Information)

        processLog.StartInfo.FileName = "notepad.exe" '( ExePathCMD ) Starts a CMD window
        processLog.StartInfo.Arguments = stringDISMLog
        processLog.EnableRaisingEvents = True
        processLog.StartInfo.UseShellExecute = True 'Must be False to redirect
        processLog.StartInfo.WindowStyle = ProcessWindowStyle.Maximized 'Just in Cases

        processLog.Start()
        processLog.Close()

        MainText.Text = stringMainTextBackUp
        MenuSelectionText.Text = stringMenuSelectionTextBackUp
        DescriptionText.Text = stringDescriptionTextBackUp

    End Sub

    Private Sub HelpToolStripMenuItemHelp_Click(sender As Object, e As EventArgs) Handles HelpToolStripMenuItemHelp.Click

        Dim stringAppDirectoryAndFile As String = String.Empty
        Dim stringHelp As String = String.Empty

        Dim stringMainTextBackUp As String = String.Empty
        Dim stringMenuSelectionTextBackUp As String = String.Empty
        Dim stringDescriptionTextBackUp As String = String.Empty

        stringMainTextBackUp = MainText.Text
        stringMenuSelectionTextBackUp = MenuSelectionText.Text
        stringDescriptionTextBackUp = DescriptionText.Text

        stringAppDirectoryAndFile = My.Application.Info.DirectoryPath & "\RepairHelpFile.rtf"
        MainText.Text = ""
        MenuSelectionText.Text = "Help ➔ Help"
        DescriptionText.Text = "Displays the help file."

        'Check for file availability
        If File.Exists(stringAppDirectoryAndFile) = False Then
            MessageBox.Show("Error : The Repair help file " & stringAppDirectoryAndFile & " is not available.", "Repair : Help File Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            MainText.Text = stringMainTextBackUp
            MenuSelectionText.Text = stringMenuSelectionTextBackUp
            DescriptionText.Text = stringDescriptionTextBackUp
            Exit Sub
        End If

        MessageBox.Show("The Repair helpfile " & stringAppDirectoryAndFile & " will conveniently be opened in a new window.", "Repair : Help File", MessageBoxButtons.OK, MessageBoxIcon.Information)

        HelpForm.HelpRichTextBox.LoadFile("RepairHelpFile.rtf")

        HelpForm.Show()

        MainText.Text = stringMainTextBackUp
        MenuSelectionText.Text = stringMenuSelectionTextBackUp
        DescriptionText.Text = stringDescriptionTextBackUp

    End Sub

    Private Sub InformationToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles InformationToolStripMenuItem.Click

        Dim stringMainTextBackUp As String = String.Empty
        Dim stringMenuSelectionTextBackUp As String = String.Empty
        Dim stringDescriptionTextBackUp As String = String.Empty

        stringMainTextBackUp = MainText.Text
        stringMenuSelectionTextBackUp = MenuSelectionText.Text
        stringDescriptionTextBackUp = DescriptionText.Text

        MainText.Text = ""
        MenuSelectionText.Text = "Help ➔ Information"
        DescriptionText.Text = "Displays some basic information on this application."

        MessageBox.Show("This application has been made by Steven Stanley Bayes." & vbCrLf & vbCrLf & "Steven.Stanley.Bayes@gmail.com" & vbCrLf & vbCrLf & "www.Steven-Stanley-Bayes.com", "Repair : Information", MessageBoxButtons.OK, MessageBoxIcon.Information)

        MainText.Text = stringMainTextBackUp
        MenuSelectionText.Text = stringMenuSelectionTextBackUp
        DescriptionText.Text = stringDescriptionTextBackUp

    End Sub

    Private Sub ExitToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ExitToolStripMenuItem.Click
        Close()
    End Sub

    Private Sub RepairMainForm_Closing(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing

        If isElevated = True Then

            Dim stringToExit As String = String.Empty

            Dim stringMainTextBackUp As String = String.Empty
            Dim stringMenuSelectionTextBackUp As String = String.Empty
            Dim stringDescriptionTextBackUp As String = String.Empty

            stringMainTextBackUp = MainText.Text
            stringMenuSelectionTextBackUp = MenuSelectionText.Text
            stringDescriptionTextBackUp = DescriptionText.Text

            MainText.Text = ""
            MenuSelectionText.Text = "Repair ➔ Exit"
            DescriptionText.Text = "Exits the application."

            Dim intTempStatus As Integer = 0
            intTempStatus = DoAnySFCOrDISMRunNow()
            If intTempStatus >= 20 Then
                intTempStatus -= 20
            End If
            Select Case intTempStatus
        'Select Case StripStatusOfSfcAndDism(DoAnySFCOrDISMRunNow())
                Case 0
                    stringToExit = "Attention : All possible Command Prompt windows will be closed."
                Case 1
                    stringToExit = "Attention : All possible Command Prompt windows will be closed." & vbCrLf & vbCrLf & "Attention : SFC still runs now." & vbCrLf & vbCrLf & "After the application is closed, SFC may continue to run in the background and cannot be stopped ( may be possible to be stopped with Task Manager but this is not adviseable ), although the main application as well as all of the possible Command Prompt windows may be closed, whether opened by this application or not."
                Case 2
                    stringToExit = "Attention : All possible Command Prompt windows will be closed." & vbCrLf & vbCrLf & "Attention : DISM still runs now." & vbCrLf & vbCrLf & "After the application is closed, DISM may continue to run in the background and cannot be stopped ( may be possible to be stopped with Task Manager but this is not adviseable ), although the main application as well as all of the possible Command Prompt windows may be closed, whether opened by this application or not."
                Case 3
                    stringToExit = "Attention : All possible Command Prompt windows will be closed." & vbCrLf & vbCrLf & "Attention : SFC and DISM still run now." & vbCrLf & vbCrLf & "After the application is closed, SFC and DISM may continue to run in the background and cannot be stopped ( may be possible to be stopped with Task Manager but this is not adviseable ), although the main application as well as all of the possible Command Prompt windows may be closed, whether opened by this application or not."
                Case 10
                    If boolRealSelectionStarted = True Then
                        stringToExit = "Attention : All possible Command Prompt windows will be closed." & vbCrLf & vbCrLf & "Attention : The menu selection still runs now or the menu selection has been incorrectly closed." & vbCrLf & vbCrLf & "After the application is closed, SFC and or DISM may continue to run in the background and cannot be stopped ( may be possible to be stopped with Task Manager but this is not adviseable ), although the main application as well as all of the possible Command Prompt windows may be closed, whether opened by this application or not."
                    Else
                        stringToExit = "Attention : All possible Command Prompt windows will be closed." & vbCrLf & vbCrLf & "Attention : A menu selection may still run now or a menu selection has been incorrectly closed." & vbCrLf & vbCrLf & "After the application is closed, SFC and or DISM may continue to run in the background and cannot be stopped ( may be possible to be stopped with Task Manager but this is not adviseable ), although the main application as well as all of the possible Command Prompt windows may be closed, whether opened by this application or not."
                    End If
                Case 11
                    stringToExit = "Attention : All possible Command Prompt windows will be closed." & vbCrLf & vbCrLf & "Attention : The menu selection and SFC still run now." & vbCrLf & vbCrLf & "After the application is closed, SFC may continue to run in the background and cannot be stopped ( may be possible to be stopped with Task Manager but this is not adviseable ), although the main application as well as all of the possible Command Prompt windows may be closed, whether opened by this application or not."
                Case 12
                    stringToExit = "Attention : All possible Command Prompt windows will be closed." & vbCrLf & vbCrLf & "Attention : The menu selection and DISM still run now." & vbCrLf & vbCrLf & "After the application is closed, DISM may continue to run in the background and cannot be stopped ( may be possible to be stopped with Task Manager but this is not adviseable ), although the main application as well as all of the possible Command Prompt windows may be closed, whether opened by this application or not."
                Case 13
                    stringToExit = "Attention : All possible Command Prompt windows will be closed." & vbCrLf & vbCrLf & "Attention : The menu selection, SFC and DISM still run now." & vbCrLf & vbCrLf & "After the application is closed, SFC and DISM may continue to run in the background and cannot be stopped ( may be possible to be stopped with Task Manager but this is not adviseable ), although the main application as well as all of the possible Command Prompt windows may be closed, whether opened by this application or not."
                Case Else
                    stringToExit = "Attention : All possible Command Prompt windows will be closed." & vbCrLf & vbCrLf & "After the application is closed, some processes may continue to run in the background and cannot be stopped ( may be possible to be stopped with Task Manager but this is not adviseable ), although the main application as well as all of the possible Command Prompt windows may be closed, whether opened by this application or not."
            End Select

            'Display a message asking the user to save changes or abort.
            If MessageBox.Show(stringToExit & vbCrLf & vbCrLf & "In case there is any work which needs to be saved, do not exit but save your work and exit when ready." & vbCrLf & vbCrLf & "Again, upon exit, all possible Command Prompt windows will be closed, whether opened by this application or not." & vbCrLf & vbCrLf & "Do you really want to exit?", "Repair : Exit", MessageBoxButtons.YesNo, MessageBoxIcon.Question) <> DialogResult.Yes Then

                MainText.Text = stringMainTextBackUp
                MenuSelectionText.Text = stringMenuSelectionTextBackUp
                DescriptionText.Text = stringDescriptionTextBackUp

                ' Cancel the Closing event from closing the form.
                e.Cancel = True
            Else

                BeforeExit()

            End If

        End If

    End Sub

    Private Sub BeforeExit()

        Dim intToFile As Integer = 0
        Dim processLog As New Process()

        processLog.StartInfo.FileName = "powercfg" '( ExePathCMD ) Starts a CMD window
        processLog.StartInfo.Arguments = "/hibernate on"
        processLog.Start()
        processLog.Close()

        intToFile = DoAnySFCOrDISMRunNow()
        If (intToFile >= 10 And intToFile < 20) Or intToFile >= 30 Then
            File.WriteAllText("DoesRunUncompleted.txt", UncompletedText.Text)
        End If

        If intToFile >= 20 Then
            File.WriteAllText("DoesRunExited.txt", ExitedText.Text)
        Else
            If File.Exists("DoesRunExited.txt") = True Then
                File.Delete("DoesRunExited.txt")
            End If
        End If

        threadSfcAndDismRunCheck.Abort()
        While threadSfcAndDismRunCheck.IsAlive() = True
            Threading.Thread.Sleep(10)
        End While

        threadForDOS.Abort()
        While threadForDOS.IsAlive() = True
            Threading.Thread.Sleep(10)
        End While

        'Close all command prompts
        CloseAllCMD()

    End Sub

    Private Sub RunDOS(ByVal stringArgumentsAdditive As String, ByVal stringRun As String)
        processDOS.StartInfo.Arguments = stringArgumentsAdditive & " " & stringRun
        threadForDOS = New Threading.Thread(AddressOf threadForDOSSub)
        threadForDOS.Start()
    End Sub

    Sub threadForDOSSub()
        intTheDOSProcessStartedInThread = 1
        processDOS.Start()
        processDOS.WaitForExit()
        'processDOS.Close() 'DANGER WHEN KILL ALSO UNASSIGNS processDOS FROM THE OBJECT. Not known.
        intTheDOSProcessStartedInThread = 2
    End Sub

    Private Sub CloseAllCMD()
        'Close all CMD.EXE windows ( Command Prompts )

        'NO! DO NOT USE! MUST BE SURE THE PROCESS HAS BEEN STARTED TO USE THIS. AFTER processDOS.Close, GENERATES EXCEPTION BECAUSE processDOS IS UNASSIGNED.
        'CAN ONLY BE USED AFTER START AND BEFORE CLOSE OR CLOSE MUST BE OMMITED EVERYWHERE.
        'If processDOS.Equals(Nothing) = False Then
        '    If processDOS.HasExited() = False Then
        '        processDOS.Close()
        '    End If
        'End If

        Dim objprocesscheck As Process
        Dim objprocessallprocesses As Process()
        objprocessallprocesses = Process.GetProcessesByName("cmd")
        For Each objprocesscheck In objprocessallprocesses
            objprocesscheck.Kill()
        Next
    End Sub

    Private Function AskToContinue() As DialogResult
        AskToContinue = MessageBox.Show("Attention : All Command Prompt windows will be closed." & vbCrLf & vbCrLf & "All of the Command Prompt windows will be closed, whether opened by this application or not." & vbCrLf & vbCrLf & "In case there is any work which needs to be saved, do not continue, save your work and, when ready, welcome back." & vbCrLf & vbCrLf & "In case there is not any work which needs to be saved, please, continue." & vbCrLf & vbCrLf & "Again, to continue with this application, all possible Command Prompt windows will be closed, whether opened by this application or not." & vbCrLf & vbCrLf & "Do you want to continue?", "Repair : Command Prompt Windows Closure", MessageBoxButtons.YesNo, MessageBoxIcon.Question)
    End Function

    Private Function AskForSFCOrDISMRun() As Boolean

        Dim boolSMCOrDISMRun As Boolean = False
        Dim intWhatRuns As Integer = 0

        boolSMCOrDISMRun = False
        intWhatRuns = 0

        intWhatRuns = DoAnySFCOrDISMRunNow()
        If intWhatRuns >= 20 Then
            intWhatRuns -= 20
        End If
        Select Case intWhatRuns
            Case 0
                boolSMCOrDISMRun = False
            Case 1
                MessageBox.Show("Attention : An SFC process ( es ) has been started and currently runs." & vbCrLf & vbCrLf & "No new process can be started until the current one completes." & vbCrLf & vbCrLf & "Try again in a while.", "Repair : SFC Runs Now", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                boolSMCOrDISMRun = True
            Case 2
                MessageBox.Show("Attention : A DISM process ( es ) has been started and currently runs." & vbCrLf & vbCrLf & "No new process can be started until the current one completes." & vbCrLf & vbCrLf & "Try again in a while.", "Repair : DISM Runs Now", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                boolSMCOrDISMRun = True
            Case 3
                MessageBox.Show("Attention : An SFC process ( es ) and a DISM process ( es ) have been started and currently run." & vbCrLf & vbCrLf & "No new processes can be started until the current one ( s ) complete." & vbCrLf & vbCrLf & "Try again in a while.", "Repair : SFC and DISM Run Now", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                boolSMCOrDISMRun = True
            Case 10
                If boolRealSelectionStarted = True Then
                    MessageBox.Show("Attention : The menu selection has been started and currently runs or the menu selection has been incorrectly closed." & vbCrLf & vbCrLf & "No new process can be started until the current one completes." & vbCrLf & vbCrLf & "Try again in a while.", "Repair : The Menu Selection Runs Now", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    boolSMCOrDISMRun = True
                Else
                    MessageBox.Show("Attention : A menu selection has been started, may run or has been incorrectly closed." & vbCrLf & vbCrLf & "A new process can be started by this application as the previously started process may have completed but SFC and DISM may refuse to start before the previously started SFC and DISM fully complete.", "Repair : A Menu Selection May Run Now or Incorrectly Closed", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                    boolSMCOrDISMRun = False
                End If
            Case 11
                MessageBox.Show("Attention : The menu selection and an SFC process ( es ) have been started and currently run." & vbCrLf & vbCrLf & "No new process can be started until the current ones complete." & vbCrLf & vbCrLf & "Try again in a while.", "Repair : The Menu Selection and SFC Run Now", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                boolSMCOrDISMRun = True
            Case 12
                MessageBox.Show("Attention : The menu selection and a DISM process ( es ) have been started and currently run." & vbCrLf & vbCrLf & "No new process can be started until the current ones complete." & vbCrLf & vbCrLf & "Try again in a while.", "Repair : The Menu Selection and DISM Run Now", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                boolSMCOrDISMRun = True
            Case 13
                MessageBox.Show("Attention : The menu selection, an SFC process ( es ) and a DISM process ( es ) have been started and currently run." & vbCrLf & vbCrLf & "No new processes can be started until the current ones complete." & vbCrLf & vbCrLf & "Try again in a while.", "Repair : The Menu Selection, SFC and DISM Run Now", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                boolSMCOrDISMRun = True
            Case Else
                MessageBox.Show("Error : A check has been performed to find out whether SFC and DISM have been started and currently run." & vbCrLf & vbCrLf & "There is an unexpected error caused by this check.", "Repair : Menu Selection, SFC or DISM Unexpected Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                boolSMCOrDISMRun = True
        End Select

        AskForSFCOrDISMRun = boolSMCOrDISMRun

    End Function

    Private Function DoAnySFCOrDISMRunNow() As Integer

        Dim objprocesscheck As Process
        Dim objprocessallprocesses As Process()

        Dim SFCRunsNow As Integer = 0
        Dim DISMRunsNow As Integer = 0

        Dim BatchRunsNow As Integer = 0

        Dim ManualClose As Integer = 0

        SFCRunsNow = 0
        DISMRunsNow = 0
        BatchRunsNow = 0
        ManualClose = 0

        objprocessallprocesses = Process.GetProcessesByName("sfc")
        For Each objprocesscheck In objprocessallprocesses
            SFCRunsNow = 1
        Next

        objprocessallprocesses = Process.GetProcessesByName("dism")
        For Each objprocesscheck In objprocessallprocesses
            DISMRunsNow = 2
        Next

        If File.Exists("DoesRun.txt") = True Then
            File.SetAttributes("DoesRun.txt", FileAttributes.Normal)
            Dim objStreamDoesRunFile As Stream = New FileStream("DoesRun.txt", FileMode.Open, FileAccess.Read, FileShare.ReadWrite)
            File.SetAttributes("DoesRun.txt", FileAttributes.Normal)
            If objStreamDoesRunFile.ReadByte() = 89 Then
                BatchRunsNow = 10
            Else
                BatchRunsNow = 0
            End If
            objStreamDoesRunFile.Close()
        Else
            BatchRunsNow = 0
        End If

        If intTheDOSProcessStartedInThread = 2 Then
            ManualClose = 20
        End If

        DoAnySFCOrDISMRunNow = ManualClose + BatchRunsNow + SFCRunsNow + DISMRunsNow

    End Function

    Private Sub CheckSfcAndDismInAThread()
        iCounter = 1
        While iCounter > 0
            intStatusOfSfcAndDism = DoAnySFCOrDISMRunNow()
            If intStatusOfSfcAndDism <> intPreviousSfcAndDismStatus Then
                intPreviousSfcAndDismStatus = intStatusOfSfcAndDism
                StatusText.BeginInvoke(New InvokeDelegate(AddressOf InvokeMethod))
            End If
            iCounter += 1
            If iCounter > 16 Then
                iCounter = 1
            End If
            Threading.Thread.Sleep(contIntTheThreadPeriod)
        End While
    End Sub

    'Private Function StripStatusOfSfcAndDism(intTheNonStrippedStatus As Integer)

    '    Dim intTheLocalStatus As Integer = 0

    '    If intTheNonStrippedStatus >= 30 Then
    '        intTheLocalStatus = intTheNonStrippedStatus - 30
    '    Else
    '        If intTheNonStrippedStatus >= 20 Then
    '            intTheLocalStatus = intTheNonStrippedStatus - 20
    '        Else
    '            If intTheNonStrippedStatus >= 10 Then
    '                intTheLocalStatus = intTheNonStrippedStatus - 10
    '            Else
    '                intTheLocalStatus = intTheNonStrippedStatus
    '            End If
    '        End If
    '    End If

    '    StripStatusOfSfcAndDism = intTheLocalStatus

    'End Function

    Public Sub InvokeMethod()

        If boolRealSelectionStarted = True Then
            If intStatusOfSfcAndDism >= 30 Then
                stringUncompletedMenuOption = MenuSelectionText.Text
                UncompletedText.Text = stringUncompletedMenuOption
                UncompletedText.BackColor = Color.FromArgb(192, 0, 0)
                stringManuallyExitedMenuOption = MenuSelectionText.Text
                ExitedText.Text = stringManuallyExitedMenuOption
                ExitedText.BackColor = Color.FromArgb(192, 0, 0)
            Else
                If intStatusOfSfcAndDism >= 20 Then
                    stringUncompletedMenuOption = "None."
                    UncompletedText.Text = stringUncompletedMenuOption
                    UncompletedText.BackColor = Color.FromArgb(0, 192, 0)
                    stringManuallyExitedMenuOption = MenuSelectionText.Text
                    ExitedText.Text = stringManuallyExitedMenuOption
                    ExitedText.BackColor = Color.FromArgb(192, 0, 0)
                Else
                    If intStatusOfSfcAndDism >= 10 Then
                        stringUncompletedMenuOption = MenuSelectionText.Text
                        UncompletedText.Text = stringUncompletedMenuOption
                        UncompletedText.BackColor = Color.FromArgb(192, 0, 0)
                        stringManuallyExitedMenuOption = "None."
                        ExitedText.Text = stringManuallyExitedMenuOption
                        ExitedText.BackColor = Color.FromArgb(0, 192, 0)
                    Else
                        stringUncompletedMenuOption = "None."
                        UncompletedText.Text = stringUncompletedMenuOption
                        UncompletedText.BackColor = Color.FromArgb(0, 192, 0)
                        stringManuallyExitedMenuOption = "None."
                        ExitedText.Text = stringManuallyExitedMenuOption
                        ExitedText.BackColor = Color.FromArgb(0, 192, 0)
                    End If
                End If
            End If
        End If

        Dim intWhatRuns As Integer = 0
        intWhatRuns = intStatusOfSfcAndDism
        If intWhatRuns >= 20 Then
            intWhatRuns -= 20
        End If
        Select Case intWhatRuns
            Case 0
                GrayMenu(False)
                StatusText.BackColor = Color.FromArgb(0, 192, 0)
                StatusText.Text = "Neither SFC nor DISM runs now."
            Case 1
                GrayMenu(True)
                StatusText.BackColor = Color.FromArgb(192, 0, 0)
                StatusText.Text = "SFC runs now, DISM does not."
            Case 2
                GrayMenu(True)
                StatusText.BackColor = Color.FromArgb(192, 0, 0)
                StatusText.Text = "DISM runs now, SFC does not."
            Case 3
                GrayMenu(True)
                StatusText.BackColor = Color.FromArgb(192, 0, 0)
                StatusText.Text = "SFC and DISM run now."
            Case 10
                '10 caused by initialisation or a menu selection run?
                If boolRealSelectionStarted = True Then
                    GrayMenu(True)
                    StatusText.BackColor = Color.FromArgb(192, 0, 0)
                    StatusText.Text = UncompletedText.Text & " may still run now."
                Else
                    GrayMenu(False)
                    StatusText.BackColor = Color.FromArgb(0, 192, 0)
                    StatusText.Text = UncompletedText.Text & " may have been incorrectly closed."
                End If
            Case 11
                GrayMenu(True)
                StatusText.BackColor = Color.FromArgb(192, 0, 0)
                If boolRealSelectionStarted = True Then
                    StatusText.Text = "The menu selection and SFC run now, DISM does not."
                Else
                    StatusText.Text = "A menu selection and SFC run now, DISM does not."
                End If
            Case 12
                GrayMenu(True)
                StatusText.BackColor = Color.FromArgb(192, 0, 0)
                If boolRealSelectionStarted = True Then
                    StatusText.Text = "The menu selection and DISM run now, SFC does not."
                Else
                    StatusText.Text = "A menu selection and DISM run now, SFC does not."
                End If
            Case 13
                GrayMenu(True)
                StatusText.BackColor = Color.FromArgb(192, 0, 0)
                If boolRealSelectionStarted = True Then
                    StatusText.Text = "The menu selection, SFC and DISM run now."
                Else
                    StatusText.Text = "A menu selection, SFC and DISM run now."
                End If
            Case Else
                GrayMenu(False)
                StatusText.BackColor = Color.Black
                StatusText.Text = "Unexpected error."
        End Select

        LightShine(intStatusOfSfcAndDism)

    End Sub

    Private Sub GrayMenu(boolGray As Boolean)
        If boolGray = True Then
            RunAllToolStripMenuItem.Enabled = False
            ScanCleanAndReapirWithSFCAndDISMToolStripMenuItem.Enabled = False
            ScanAndCleanWithDISMRepairWithSFCOnlyToolStripMenuItem.Enabled = False
            ScanAndRepairWithSFCOnlyToolStripMenuItem.Enabled = False
            ResetBaseOnlyToolStripMenuItem.Enabled = False
            SupersededOnlyToolStripMenuItem.Enabled = False
        Else
            RunAllToolStripMenuItem.Enabled = True
            ScanCleanAndReapirWithSFCAndDISMToolStripMenuItem.Enabled = True
            ScanAndCleanWithDISMRepairWithSFCOnlyToolStripMenuItem.Enabled = True
            ScanAndRepairWithSFCOnlyToolStripMenuItem.Enabled = True
            ResetBaseOnlyToolStripMenuItem.Enabled = True
            SupersededOnlyToolStripMenuItem.Enabled = True
        End If
    End Sub

    Private Sub LightShine(ByVal intTheStatus As Integer)

        Dim solidBrushOut As SolidBrush
        Dim solidBrushIn As SolidBrush

        Dim theGraphics As Graphics = CreateGraphics()
        Dim theRectangleOut As New Rectangle
        Dim theRectangleIn As New Rectangle
        Dim objPointStatusLabelText As Point
        Dim inttStatusLabelHeight As Integer = 0

        objPointStatusLabelText = StatusLabel.Location
        inttStatusLabelHeight = StatusLabel.Height

        Dim intWhatRuns As Integer = 0
        intWhatRuns = intTheStatus
        If intWhatRuns >= 20 Then
            intWhatRuns -= 20
        End If
        Select Case intWhatRuns
            Case 0
                solidBrushOut = New SolidBrush(Color.FromArgb(0, 192, 0))
                solidBrushIn = New SolidBrush(Color.LightGreen)
            Case 1
                solidBrushOut = New SolidBrush(Color.FromArgb(192, 0, 0))
                solidBrushIn = New SolidBrush(Color.Red)
            Case 2
                solidBrushOut = New SolidBrush(Color.FromArgb(192, 0, 0))
                solidBrushIn = New SolidBrush(Color.Red)
            Case 3
                solidBrushOut = New SolidBrush(Color.FromArgb(192, 0, 0))
                solidBrushIn = New SolidBrush(Color.Red)
            Case 10
                '10 caused by initialisation or a menu selection run?
                If boolRealSelectionStarted = True Then
                    solidBrushOut = New SolidBrush(Color.FromArgb(192, 0, 0))
                    solidBrushIn = New SolidBrush(Color.Red)
                Else
                    solidBrushOut = New SolidBrush(Color.FromArgb(0, 192, 0))
                    solidBrushIn = New SolidBrush(Color.LightGreen)
                End If
            Case 11
                solidBrushOut = New SolidBrush(Color.FromArgb(192, 0, 0))
                solidBrushIn = New SolidBrush(Color.Red)
            Case 12
                solidBrushOut = New SolidBrush(Color.FromArgb(192, 0, 0))
                solidBrushIn = New SolidBrush(Color.Red)
            Case 13
                solidBrushOut = New SolidBrush(Color.FromArgb(192, 0, 0))
                solidBrushIn = New SolidBrush(Color.Red)
            Case Else
                solidBrushOut = New SolidBrush(Color.Black)
                solidBrushIn = New SolidBrush(Color.Gray)
        End Select

        theRectangleOut.X = 0
        theRectangleOut.Y = objPointStatusLabelText.Y
        theRectangleOut.Width = inttStatusLabelHeight
        theRectangleOut.Height = inttStatusLabelHeight

        theRectangleIn.X = theRectangleOut.X + theRectangleOut.Width / 4
        theRectangleIn.Y = theRectangleOut.Y + theRectangleOut.Height / 4
        theRectangleIn.Width = theRectangleOut.Width / 2
        theRectangleIn.Height = theRectangleOut.Height / 2

        theGraphics.FillEllipse(solidBrushOut, theRectangleOut)
        theGraphics.FillEllipse(solidBrushIn, theRectangleIn)

    End Sub

    Private Sub MyForm_Layout(ByVal sender As Object, ByVal e As LayoutEventArgs) Handles MyBase.Layout
        ResizeAndPosition()
    End Sub

    Private Sub ResizeAndPosition()

        Const constIntPixelBuffer As Integer = 10
        Const constIntMinTextWidth As Integer = 200
        Const constIntMinTextHeight As Integer = 150

        Dim objRectangleMainFormClientArea As Rectangle
        Dim intMenuStripHeight = 0
        Dim intBufferAdjust As Integer = 0
        'Dim stringText As String = String.Empty

        Dim intXMenuChoiceLabel As Integer = 0
        Dim intYMenuChoiceLabel As Integer = 0

        Dim intXMenuSelectionText As Integer = 0
        Dim intYMenuSelectionText As Integer = 0
        Dim intWidthMenuSelectionText As Integer = 0

        Dim intXStatusLabel As Integer = 0
        Dim intYStatusLabel As Integer = 0

        Dim intXStatusText As Integer = 0
        Dim intYStatusText As Integer = 0
        Dim intWidthStatusText As Integer = 0

        Dim intXUncomletedLabel As Integer = 0
        Dim intYUncomletedLabel As Integer = 0

        Dim intXUncompletedText As Integer = 0
        Dim intYUncompletedText As Integer = 0
        Dim intWidthUncompletedText As Integer = 0

        Dim intXManuallyExitedLabel As Integer = 0
        Dim intYManuallyExitedLabel As Integer = 0

        Dim intXExitedText As Integer = 0
        Dim intYExitedText As Integer = 0
        Dim intWidthExitedText As Integer = 0

        Dim intXMainLabel As Integer = 0
        Dim intYMainLabel As Integer = 0

        Dim intXMainText As Integer = 0
        Dim intYMainText As Integer = 0
        Dim intWidthMainText As Integer = 0
        Dim intHeightMainText As Integer = 0

        Dim intXDescriptionLabel As Integer = 0
        Dim intYDescriptionLabel As Integer = 0

        Dim intXDescriptionText As Integer = 0
        Dim intYDescriptionText As Integer = 0
        Dim intWidthDescriptionText As Integer = 0
        Dim intHeightDescriptionText As Integer = 0

        objRectangleMainFormClientArea = ClientRectangle
        intMenuStripHeight = MainMenuStrip.Height

        'MenuChoieLabel
        intXMenuChoiceLabel = objRectangleMainFormClientArea.Width / 2 - MenuChoiceLabel.Width / 2
        intYMenuChoiceLabel = objRectangleMainFormClientArea.Y + intMenuStripHeight + constIntPixelBuffer
        intBufferAdjust = constIntPixelBuffer
        While objRectangleMainFormClientArea.Width < MenuChoiceLabel.Width + 2 * intBufferAdjust And intBufferAdjust > 0
            intBufferAdjust -= 1
            intXMenuChoiceLabel = intBufferAdjust
        End While
        If intXMenuChoiceLabel < 0 Then
            intXMenuChoiceLabel = 0
        End If
        MenuChoiceLabel.Location = New Point(intXMenuChoiceLabel, intYMenuChoiceLabel)
        'MenuChoieLabel Width and Heigth are automatic so far.

        'MenuSelectionText
        'stringText = MenuSelectionText.Text
        intXMenuSelectionText = constIntPixelBuffer
        intYMenuSelectionText = intYMenuChoiceLabel + MenuChoiceLabel.Height + constIntPixelBuffer / 2
        MenuSelectionText.Location = New Point(intXMenuSelectionText, intYMenuSelectionText)
        intWidthMenuSelectionText = objRectangleMainFormClientArea.Width - 2 * constIntPixelBuffer
        If intWidthMenuSelectionText < constIntMinTextWidth Then
            intWidthMenuSelectionText = constIntMinTextWidth
        End If
        MenuSelectionText.Width = intWidthMenuSelectionText
        'MenuSelectionText.Text = stringText

        'StatusLabel
        intXStatusLabel = objRectangleMainFormClientArea.Width / 2 - StatusLabel.Width / 2
        intYStatusLabel = intYMenuSelectionText + MenuSelectionText.Height + constIntPixelBuffer
        intBufferAdjust = constIntPixelBuffer
        While objRectangleMainFormClientArea.Width < StatusLabel.Width + 2 * intBufferAdjust And intBufferAdjust > 0
            intBufferAdjust -= 1
            intXStatusLabel = intBufferAdjust
        End While
        If intXStatusLabel < 0 Then
            intXStatusLabel = 0
        End If
        StatusLabel.Location = New Point(intXStatusLabel, intYStatusLabel)
        'MenuChoieLabel Width and Heigth are automatic so far.

        'StatusText
        'stringText = StatusText.Text
        intXStatusText = constIntPixelBuffer
        intYStatusText = intYStatusLabel + StatusLabel.Height + constIntPixelBuffer / 2
        StatusText.Location = New Point(intXStatusText, intYStatusText)
        intWidthStatusText = objRectangleMainFormClientArea.Width - 2 * constIntPixelBuffer
        If intWidthStatusText < constIntMinTextWidth Then
            intWidthStatusText = constIntMinTextWidth
        End If
        StatusText.Width = intWidthStatusText
        'StatusText.Text = stringText

        'UncomletedLabel
        intXUncomletedLabel = objRectangleMainFormClientArea.Width / 2 - UncomletedLabel.Width / 2
        intYUncomletedLabel = intYStatusText + StatusText.Height + constIntPixelBuffer
        intBufferAdjust = constIntPixelBuffer
        While objRectangleMainFormClientArea.Width < UncomletedLabel.Width + 2 * intBufferAdjust And intBufferAdjust > 0
            intBufferAdjust -= 1
            intXUncomletedLabel = intBufferAdjust
        End While
        If intXUncomletedLabel < 0 Then
            intXUncomletedLabel = 0
        End If
        UncomletedLabel.Location = New Point(intXUncomletedLabel, intYUncomletedLabel)
        'MenuChoieLabel Width and Heigth are automatic so far.

        'UncompletedText
        'stringText = UncompletedText.Text
        intXUncompletedText = constIntPixelBuffer
        intYUncompletedText = intYUncomletedLabel + UncomletedLabel.Height + constIntPixelBuffer / 2
        UncompletedText.Location = New Point(intXUncompletedText, intYUncompletedText)
        intWidthUncompletedText = objRectangleMainFormClientArea.Width - 2 * constIntPixelBuffer
        If intWidthUncompletedText < constIntMinTextWidth Then
            intWidthUncompletedText = constIntMinTextWidth
        End If
        UncompletedText.Width = intWidthUncompletedText
        'UncompletedText.Text = stringText

        'ManuallyExitedLabel
        intXManuallyExitedLabel = objRectangleMainFormClientArea.Width / 2 - ManuallyExitedLabel.Width / 2
        intYManuallyExitedLabel = intYUncompletedText + UncompletedText.Height + constIntPixelBuffer
        intBufferAdjust = constIntPixelBuffer
        While objRectangleMainFormClientArea.Width < ManuallyExitedLabel.Width + 2 * intBufferAdjust And intBufferAdjust > 0
            intBufferAdjust -= 1
            intXManuallyExitedLabel = intBufferAdjust
        End While
        If intXManuallyExitedLabel < 0 Then
            intXManuallyExitedLabel = 0
        End If
        ManuallyExitedLabel.Location = New Point(intXManuallyExitedLabel, intYManuallyExitedLabel)
        'MenuChoieLabel Width and Heigth are automatic so far.

        'ExitedText
        'stringText = ExitedText.Text
        intXExitedText = constIntPixelBuffer
        intYExitedText = intYManuallyExitedLabel + ManuallyExitedLabel.Height + constIntPixelBuffer / 2
        ExitedText.Location = New Point(intXExitedText, intYExitedText)
        intWidthExitedText = objRectangleMainFormClientArea.Width - 2 * constIntPixelBuffer
        If intWidthExitedText < constIntMinTextWidth Then
            intWidthExitedText = constIntMinTextWidth
        End If
        ExitedText.Width = intWidthExitedText
        'ExitedText.Text = stringText

        'MainLabel
        intXMainLabel = objRectangleMainFormClientArea.Width / 2 - MainLabel.Width / 2
        intYMainLabel = intYExitedText + ExitedText.Height + constIntPixelBuffer
        intBufferAdjust = constIntPixelBuffer
        While objRectangleMainFormClientArea.Width < MainLabel.Width + 2 * intBufferAdjust And intBufferAdjust > 0
            intBufferAdjust -= 1
            intXMainLabel = intBufferAdjust
        End While
        If intXMainLabel < 0 Then
            intXMainLabel = 0
        End If
        MainLabel.Location = New Point(intXMainLabel, intYMainLabel)
        'MainLabel Width and Heigth are automatic so far.

        'MainText
        'stringText = MainText.Text
        intXMainText = constIntPixelBuffer
        intYMainText = intYMainLabel + MainLabel.Height + constIntPixelBuffer / 2
        MainText.Location = New Point(intXMainText, intYMainText)
        intWidthMainText = objRectangleMainFormClientArea.Width - 2 * constIntPixelBuffer
        If intWidthMainText < constIntMinTextWidth Then
            intWidthMainText = constIntMinTextWidth
        End If
        intHeightMainText = objRectangleMainFormClientArea.Height / 4
        If intHeightMainText < constIntMinTextHeight Then
            intHeightMainText = constIntMinTextHeight
        End If
        MainText.Width = intWidthMainText
        MainText.Height = intHeightMainText
        'MainText.Text = stringText

        'DescriptionLabel
        intXDescriptionLabel = objRectangleMainFormClientArea.Width / 2 - DescriptionLabel.Width / 2
        intYDescriptionLabel = intYMainText + MainText.Height + constIntPixelBuffer
        intBufferAdjust = constIntPixelBuffer
        While objRectangleMainFormClientArea.Width < DescriptionLabel.Width + 2 * intBufferAdjust And intBufferAdjust > 0
            intBufferAdjust -= 1
            intXDescriptionLabel = intBufferAdjust
        End While
        If intXDescriptionLabel < 0 Then
            intXDescriptionLabel = 0
        End If
        DescriptionLabel.Location = New Point(intXDescriptionLabel, intYDescriptionLabel)
        'DescriptionLabel Width and Heigth are automatic so far.

        'DescriptionText
        'stringText = DescriptionText.Text
        intXDescriptionText = constIntPixelBuffer
        intYDescriptionText = intYDescriptionLabel + DescriptionLabel.Height + constIntPixelBuffer / 2
        DescriptionText.Location = New Point(intXDescriptionText, intYDescriptionText)
        intWidthDescriptionText = objRectangleMainFormClientArea.Width - 2 * constIntPixelBuffer
        If intWidthDescriptionText < constIntMinTextWidth Then
            intWidthDescriptionText = constIntMinTextWidth
        End If
        intHeightDescriptionText = objRectangleMainFormClientArea.Height - intYDescriptionText - constIntPixelBuffer
        If intHeightDescriptionText < constIntMinTextHeight Then
            intHeightDescriptionText = constIntMinTextHeight
        End If
        DescriptionText.Width = intWidthDescriptionText
        DescriptionText.Height = intHeightDescriptionText
        'DescriptionText.Text = stringText

        LightShine(intStatusOfSfcAndDism)

    End Sub

End Class
